# ifndef __CINT__
# ifndef __ether_h
# define __ether_h

#define HOST_NAME "bec"
#define SOCK_PORT 2700
#define PORT_TRY  5
#define SOCK_TIMEOUT 30000
#define BUFLEN 256
#define ASCII 10
#define BINARY 0
#define ERROR -1

# include <sys/types.h>
# include <sys/socket.h>
# include <arpa/inet.h>
# include <netinet/in.h>
# include <netdb.h>

#ifdef __cplusplus
extern "C" {
#endif
int sconnect  ( int, char ** );
int disconnect( void );
int opensock  ( char *, int, int * );
int closesock ( int );
int readsock  ( int , unsigned char *, int, int );
int writesock ( int , unsigned char *, int, int );
int decodemsg ( unsigned char *, int );
int openbox   ( int );
int closebox  ( int );
int readcmd   ( unsigned char *, int, int * );
int writecmd  ( unsigned char *, int, int * );
int execcmd   ( unsigned char * );
int remstart  ( char * );
#ifdef __cplusplus
}
#endif

#endif
#endif
