// pulse.h - SUMMA pulse generator 
//
// Nov-2004 by Solo
//

#ifndef _PULSE_H
#define _PULSE_H

#include "le20c.h"

class PULSE
{

 public:
// Constructor and destructor
  PULSE (LE20C* host, int number=14)
  {
    h = host;
    n = number;
  }

  ~PULSE () {}

// Functions and procedures
  void pulse(int chan) { h->act(n,chan,25); }

  void ped() { pulse(0); }
  void led() { pulse(2); }
  void oc()  { pulse(4); }

 private:
  LE20C* h; // QBUS-SUMMA host
  int n;    // position in crate
};

# endif
