#!/bin/sh

   rm -f pciqb_test0.cxx pciqb_test0.exe

cat >pciqb_test0.cxx <<EOF
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/io.h>

    int BASE=0x6500, offset=0x00, value=0;
    char RW[200];

int main()
{
    setuid(0); /* if we're setuid, do it really */
    iopl(3);
    printf("\n read/write pci_qbus port 0x6500+offset.\n\n");

    while(1) {
      while(1) {
        printf("  offset [0 - 0x1e] ?  ");
        scanf("%x",&offset);
        if (offset>=0 && offset<=0x1e)  break;
      }
      while(1) {
        printf("       [Read/Write] ?  ");
        scanf("%s",RW);
        if (RW[0]=='R' || RW[0]=='r') {
          printf("                            read BASE+%2x: %08x\n\n",
                 offset, inl(BASE+offset));
          break;
        }
        if (RW[0]=='W' || RW[0]=='w') {
          printf(" hex value:  ");
          scanf("%x",&value);
          outl(value,BASE+offset);
          printf("                            written to BASE+%2x: %08x\n",
	         offset, value);
          printf("                            read from  BASE+%2x: %08x\n\n",
                 offset, inl(BASE+offset));
	  break;
        }
      }
    }
}
EOF

   gcc pciqb_test0.cxx -o pciqb_test0.exe
   rm -f pciqb_test0.cxx
   ./pciqb_test0.exe
