#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/io.h>
#include <time.h>
#include <sys/time.h>

int BASE=0xDC00, offset=0x00;
unsigned short value=0;
char RW[200];

int qbus_read(int addr, unsigned short *value) {
  int i=0;
  unsigned short s=0;
  outw(addr,BASE+8);
  while((s=inw(BASE))==0) i++; // wait for data ready
  if(s==1) *value=inw(BASE+12);
  else outw(0,BASE); // reset timeout
//  s=inw(BASE);
//  *value=inw(BASE+12);
  return i;
}

int main(int argc, char **argv)
{
    struct timeval tv0, tv1;
    double usec;
    int s;

    setuid(0); /* if we're setuid, do it really */
    iopl(3);
    printf("\n read/write pci_qbus port 0x%x+0x%x.\n\n",BASE,offset);

    printf("Testing read...");
    gettimeofday(&tv0,0);
    for(int i=0; i<1000000; i++) s=qbus_read(0xff42,&value);
    gettimeofday(&tv1,0);
    usec = (tv1.tv_sec-tv0.tv_sec)*1000000.0 + tv1.tv_usec-tv0.tv_usec;
    printf("%f usec/call\n",usec/1000000.0);
    printf("%d %x\n",s,value);

/*
    while(1) {
      while(1) {
        printf("  offset [0 - 0x1e] ?  ");
        scanf("%x",&offset);
        if (offset>=0 && offset<=0x1e)  break;
      }
      while(1) {
        printf("       [Read/Write] ?  ");
        scanf("%s",RW);
        if (RW[0]=='R' || RW[0]=='r') {
          printf("                            read BASE+%2x: %08x\n\n",
                 offset, inl(BASE+offset));
          break;
        }
        if (RW[0]=='W' || RW[0]=='w') {
          printf(" hex value:  ");
          scanf("%x",&value);
          outl(value,BASE+offset);
          printf("                            written to BASE+%2x: %08x\n",
	         offset, value);
          printf("                            read from  BASE+%2x: %08x\n\n",
                 offset, inl(BASE+offset));
	  break;
        }
      }
    }
*/
}
