// le35.h - SUMMA input register for MISS cable segment 
//
// Nov-2005 by Solo
//

#ifndef _LE35_H
#define _LE35_H

#include "le20c.h"

class LE35
{

 public:
// Constructor and destructor
  LE35 (LE20C* host, int number=21)
  {
    h = host;
    n = number;
  }

  ~LE35 () {}

// Functions and procedures
  unsigned short read() { h->read(n,0); }
  void clear() { h->act(n,a,8); }

 private:
  LE20C* h; // QBUS-SUMMA host
  int n;    // position in crate
};

# endif
