// dim_info.cc - subscribe and display dim information
//
// Nov-2008 by Solo
//

#include <stdio.h>
#include "dic.hxx"

class myInfo: public DimInfo {
public:
  myInfo(const char *name, int nolink): DimInfo(name,nolink) {}
  void infoHandler() { printf("%s %d %d\n",getName(),getSize(),getInt()); }
};

int main(int argc, char **argv) {

  char *service, *format;
  myInfo *vi[100];
  int n=0;

  if(argc<2) {
    printf("Usage: dim_info service\n");
    return -1;
  }

  DimBrowser dbr;

  dbr.getServices(argv[1]);
  while(dbr.getNextService(service,format)) {
    printf("name, format: %s, %s\n",service,format);
    vi[n++]=new myInfo(service,-1);
  }

  while(true) {
    //    printf("%s %d\n",srv.getName(),srv.getInt());
  }

}
