#ifndef LE90M_PARAMETER_H
#define LE90M_PARAMETER_H

#include <QLabel>
#include <QDoubleSpinBox>

class LE90Mparameter : public QWidget
{
 Q_OBJECT

 public:
  LE90Mparameter(const QString &text, const QString &suffix=0, bool enabled=true, QWidget *parent=0);

 public slots:
   void valueChange(double val);
   void setParameter(double val);
   double getParameter();

 signals:
   void valueChanged(double val);

 private:
  QLabel *label;
  QDoubleSpinBox *spinbox;
};

#endif
